/***********************************************************************************************
/	Copyright 2006	by Taco Cohen. All rights reserved							
/***********************************************************************************************/

// Set default screen size, color depth and fullscreen mode:
var video_mode = 8;
var video_depth = 32;
var video_screen = 1;

// Instruction text:
font ArialFont = "Arial",1,14;
text Instructions
{
	pos_x = 20;
	pos_y = 20;
	string = "
-Arrow keys or left mouse button to rotate camera round object.
-W and S or mousewheel to zoom in/out.
-Space key to start/stop sun movement.
-esc to close.";
	flags = visible;
	font = ArialFont;
}

// Declare a sky texture:
SKY SkyDay
{
	type = <sky_day.tga>;
	scale_x = 0.02;
	tilt = -60;
	layer = 10;
	alpha = 100;
	flags = CYLINDER, VISIBLE;
}

// Declare the material:
material MtlDiffuse
{
	ambient_red = 64;			// The ambient color.
	ambient_green = 64;
	ambient_blue = 64;
	effect = "Diffuse.fx";	// The effect file containing the vertex shader, pixel shader and technique.
}

function main()
{
	// Load the level:
	level_load("Diffuse.wmb");
	wait(3);
}

// Action assigned to the entity that should be shaded. Do not assign to more than 1 entity.
action ShadedEntity
{
	my.material = MtlDiffuse;	// The diffuse material.
	var CamDist = 250;			// Default camera distance.
	
	while(1)
	{
		// Rotate camera by cursor keys:
		if(key_cur){camera.pan += 5 * time_step;}
		if(key_cul){camera.pan -= 5 * time_step;}
		if(key_cuu){camera.tilt -= 5 * time_step;}
		if(key_cud){camera.tilt += 5 * time_step;}
		
		// Rotate camera by dragging the mouse:
		if(mouse_left)
		{
			camera.pan -= mickey.x * 3 * time_step;
			camera.tilt -= mickey.y * 3 * time_step;
		}
		
		// Zoom in/out with the mousewheel:
		CamDist += mickey.z / 3;
		
		// Zoom in/out with the w and s keys:
		CamDist -= (key_w - key_s) * time_step * CamDist * 0.1;
		
		// Calculate new camera position:
		temp = cos(-camera.tilt) * CamDist;
		camera.x = my.x - cos(camera.pan) * temp;
		camera.y = my.y - sin(camera.pan) * temp;
		camera.z = my.z + sin(-camera.tilt) * CamDist;
		wait(1);
	}
}

var MoveSun = ON;
function ToggleSunMovement()
{
	MoveSun = MoveSun == OFF;
}
on_space = ToggleSunMovement;
function MoveSun_startup()
{
	while(1)
	{
		if(MoveSun)
		{
			sun_angle.pan += 1.25 * time_frame; 
			sun_angle.pan %= 360; 
			sun_angle.tilt = fsin(sun_angle.pan, 45) + 45;
			//sun_light = 2 * sun_angle.tilt;
			sun_light = 500;
		}
		wait(1);
	}
}